## fenics-dolfinx 0.10.0.post5

=== cpp/CMakeLists.txt ===
# ------------------------------------------------------------------------------
# Top level CMakeLists.txt file for DOLFINx
cmake_minimum_required(VERSION 3.21)

if(POLICY CMP0167)
  cmake_policy(SET CMP0167 NEW)  # Boost CONFIG mode
endif()
if(POLICY CMP0144)
  cmake_policy(SET CMP0144 NEW)  # https://cmake.org/cmake/help/latest/policy/CMP0144.html
endif()

# ------------------------------------------------------------------------------
# Set project name and version number
project(DOLFINX VERSION "0.10.0")

set(DOXYGEN_DOLFINX_VERSION
    ${DOLFINX_VERSION}
    CACHE STRING "Version for Doxygen" FORCE
)

# ------------------------------------------------------------------------------
if(WIN32)
  # Windows requires all symbols to be manually exported. This flag exports all
  # symbols automatically, as in Unix.
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
endif()

# ------------------------------------------------------------------------------
# Get GIT changeset, if available
find_program(GIT_FOUND git)

if(GIT_FOUND)
  # Get the commit hash of the working branch
  execute_process(
    COMMAND git rev-parse HEAD
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_COMMIT_HASH
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
else()
  set(GIT_COMMIT_HASH "unknown")
endif()

# ------------------------------------------------------------------------------
# General configuration

# Set location of our FindFoo.cmake modules
set(CMAKE_MODULE_PATH ${DOLFINX_SOURCE_DIR}/cmake/modules)

# Make sure CMake uses the correct DOLFINConfig.cmake for tests and demos
list(APPEND CMAKE_PREFIX_PATH ${CMAKE_CURRENT_BINARY_DIR}/dolfinx)

# ------------------------------------------------------------------------------
# Configurable options for how we want to build
include(FeatureSummary)

option(BUILD_SHARED_LIBS "Build DOLFINx with shared libraries." ON)
add_feature_info(
  BUILD_SHARED_LIBS BUILD_SHARED_LIBS "Build DOLFINx with shared libraries."
)

# If libdolfinx links to a symbol contained in an external dll, that dll will be
# installed alongside libdolfinx. This excludes system dlls included with
# Windows.
option(INSTALL_RUNTIME_DEPENDENCIES
       "Include runtime dependencies in install (Windows-only)" OFF
)
add_feature_info(
  INSTALL_RUNTIME_DEPENDENCIES INSTALL_RUNTIME_DEPENDENCIES
  "Include runtime dependencies in install (Windows-only)"
)

option(DOLFINX_SKIP_BUILD_TESTS
       "Skip build tests for testing usability of dependency packages." OFF
)
add_feature_info(
  DOLFINX_SKIP_BUILD_TESTS DOLFINX_SKIP_BUILD_TESTS
  "Skip build tests for testing usability of dependency packages."
)

# Add shared library paths so shared libs in non-system paths are found
option(CMAKE_INSTALL_RPATH_USE_LINK_PATH
       "Add paths to linker search and installed rpath." ON
)
add_feature_info(
  CMAKE_INSTALL_RPATH_USE_LINK_PATH CMAKE_INSTALL_RPATH_USE_LINK_PATH
  "Add paths to linker search and installed rpath."
)

# Control Basix discovery
option(
  DOLFINX_BASIX_PYTHON
  "Ask Python basix module for hint where to find Basix C++ install using CONFIG mode."
  ON
)
add_feature_info(
  DOLFINX_BASIX_PYTHON
  DOLFINX_BASIX_PYTHON
  "Ask Python basix module for hint where to find Basix C++ install using CONFIG mode."
)

# Control UFCx discovery
option(
  DOLFINX_UFCX_PYTHON
  "Ask Python FFCx module where to find ufcx.h header using MODULE mode. Otherwise use CONFIG mode."
  ON
)
add_feature_info(
  DOLFINX_UFCX_PYTHON
  DOLFINX_UFCX_PYTHON
  "Ask Python FFCx module where to find ufcx.h header using MODULE mode. Otherwise use CONFIG mode."
)

# clang-tidy
option(ENABLE_CLANG_TIDY "Run clang-tidy while building" OFF)
add_feature_info(
  ENABLE_CLANG_TIDY ENABLE_CLANG_TIDY "Run clang-tidy while building"
)

# ------------------------------------------------------------------------------
# Enable or disable optional packages

if(DOLFINX_ENABLE_ADIOS2)
  set(_REQUIRE_ADIOS2 TRUE CACHE BOOL "Is ADIOS2 REQUIRED?")
else()
  set(_REQUIRE_ADIOS2 FALSE CACHE BOOL "Is ADIOS2 REQUIRED?")
endif()
option(DOLFINX_ENABLE_ADIOS2 "Compile with support for ADIOS2." ON)
set_package_properties(
  ADIOS2 PROPERTIES
  TYPE OPTIONAL
  DESCRIPTION "Adaptable Input/Output (I/O) System."
  URL "https://adios2.readthedocs.io/en/latest/"
  PURPOSE "IO, including in parallel"
)

if(DOLFINX_ENABLE_PETSC)
  set(_REQUIRE_PETSC TRUE CACHE BOOL "Is PETSc REQUIRED?")
else()
  set(_REQUIRE_PETSC FALSE CACHE BOOL "Is PETSc REQUIRED?")
endif()

option(DOLFINX_ENABLE_PETSC "Compile with support for PETSc." ON)
set_package_properties(
  PETSc PROPERTIES
  TYPE RECOMMENDED
  DESCRIPTION "Portable, Extensible Toolkit for Scientific Computation"
  URL "https://petsc.org/"
  PURPOSE "Linear and nonlinear solvers"
)

if(DOLFINX_ENABLE_PARMETIS)
  set(_REQUIRE_PARMETIS TRUE CACHE BOOL "Is Parmetis REQUIRED?")
else()
  set(_REQUIRE_PARMETIS FALSE CACHE BOOL "Is Parmetis REQUIRED?")
endif()
option(DOLFINX_ENABLE_PARMETIS "Compile with support for ParMETIS." ON)
set_package_properties(
  ParMETIS PROPERTIES
  TYPE RECOMMENDED
  DESCRIPTION "Parallel Graph Partitioning and Fill-reducing Matrix Ordering"
  URL "http://glaros.dtc.umn.edu/gkhome/metis/parmetis/overview"
  PURPOSE "Parallel graph partitioning"
)

if(DOLFINX_ENABLE_SCOTCH)
  set(_REQUIRE_SCOTCH TRUE CACHE BOOL "Is SCOTCH REQUIRED?")
else()
  set(_REQUIRE_SCOTCH FALSE CACHE BOOL "Is SCOTCH REQUIRED?")
endif()
option(DOLFINX_ENABLE_SCOTCH "Compile with support for SCOTCH." ON)
set_package_properties(
  SCOTCH PROPERTIES
  TYPE OPTIONAL
  DESCRIPTION
    "Programs and libraries for graph, mesh and hypergraph partitioning"
  URL "https://www.labri.fr/perso/pelegrin/scotch"
  PURPOSE "Parallel graph partitioning"
)

if(DOLFINX_ENABLE_SLEPC)
  set(_REQUIRE_SLEPC TRUE CACHE BOOL "Is SLEPc REQUIRED?")
else()
  set(_REQUIRE_SLEPC FALSE CACHE BOOL "Is SLEPc REQUIRED?")
endif()
option(DOLFINX_ENABLE_SLEPC "Compile with support for SLEPc." ON)
set_package_properties(
  SLEPc PROPERTIES
  TYPE RECOMMENDED
  DESCRIPTION "Scalable Library for Eigenvalue Problem Computations"
  URL "http://slepc.upv.es/"
  PURPOSE "Eigenvalue computation"
)

if(DOLFINX_ENABLE_KAHIP)
  set(_REQUIRE_KAHIP TRUE CACHE BOOL "Is KaHIP REQUIRED?")
else()
  set(_REQUIRE_KAHIP FALSE CACHE BOOL "Is KaHIP REQUIRED?")
endif()
option(DOLFINX_ENABLE_KAHIP "Compile with support for KaHIP." ON)
set_package_properties(
  KaHIP PROPERTIES
  TYPE OPTIONAL
  DESCRIPTION "A family of graph partitioning programs"
  URL "https://kahip.github.io/"
  PURPOSE "Parallel graph partitioning"
)

# ------------------------------------------------------------------------------
# Check for MPI
find_package(MPI 3 REQUIRED)

# ------------------------------------------------------------------------------
# Compiler flags

# Default build type (can be overridden by user)
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE
      "RelWithDebInfo"
      CACHE
        STRING
        "Choose the type of build, options are: Debug Developer MinSizeRel Release RelWithDebInfo."
        FORCE
  )
endif()

# Check for some compiler flags
include(CheckCXXCompilerFlag)

# Add some strict compiler checks
check_cxx_compiler_flag("-Wall -Werror -Wextra -pedantic" HAVE_PEDANTIC)

if(HAVE_PEDANTIC)
  list(APPEND DOLFINX_CXX_DEVELOPER_FLAGS -Wall;-Werror;-Wextra;-pedantic)
endif()

# Debug flags
check_cxx_compiler_flag(-g HAVE_DEBUG)
if(HAVE_DEBUG)
  list(APPEND DOLFINX_CXX_DEVELOPER_FLAGS -g)
endif()

# Optimisation
check_cxx_compiler_flag(-O2 HAVE_O2_OPTIMISATION)
if(HAVE_O2_OPTIMISATION)
  list(APPEND DOLFINX_CXX_DEVELOPER_FLAGS -O2)
endif()

# Turn off some checks in gcc12 and gcc13 due to false positives with the fmt
# library
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU"
   AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER "11.4"
   AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "14.0"
)
  list(APPEND DOLFINX_CXX_DEVELOPER_FLAGS
       -Wno-array-bounds;-Wno-stringop-overflow
  )
endif()

# ------------------------------------------------------------------------------
# Find required packages

find_package(pugixml REQUIRED)
find_package(spdlog REQUIRED)

# Note: When updating Boost version, also update DOLFINXConfig.cmake.in
if(DEFINED ENV{BOOST_ROOT} OR DEFINED BOOST_ROOT)
  set(Boost_NO_SYSTEM_PATHS on)
endif()

if (DEFINED ENV{BOOST_USE_MULTITHREADED})
  set(Boost_USE_MULTITHREADED $ENV{BOOST_USE_MULTITHREADED})
endif()
set(Boost_VERBOSE TRUE)
find_package(Boost 1.70 REQUIRED)
set_package_properties(
  Boost PROPERTIES
  TYPE REQUIRED
  DESCRIPTION "Boost C++ libraries"
  URL "http://www.boost.org"
)

# Basix C++ files can be installed as a standalone C++ library, or in
# the Basix Python module tree.

# If requested (default), ask the Python interpreter for hints on where
# to find Basix C++ library.
if(DOLFINX_BASIX_PYTHON)
  find_package(Python3 COMPONENTS Interpreter QUIET)
  if(Python3_Interpreter_FOUND)
    message(STATUS "Checking for Basix hints with ${Python3_EXECUTABLE}")
    execute_process(
      COMMAND
        ${Python3_EXECUTABLE} -c
        "import basix, os, sys; sys.stdout.write(os.path.dirname(basix.__file__))"
      OUTPUT_VARIABLE BASIX_PY_DIR
      RESULT_VARIABLE BASIX_PY_COMMAND_RESULT
      ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE
    )
  endif()

  if(BASIX_PY_DIR)
    # Converts os native to cmake native path
    cmake_path(SET BASIX_PY_DIR "${BASIX_PY_DIR}")
    message(STATUS "Adding ${BASIX_PY_DIR} to Basix search hints")

    # Basix installed from manylinux wheel requires rpath set
    if(IS_DIRECTORY ${BASIX_PY_DIR}/../fenics_basix.libs)
      set(CMAKE_INSTALL_RPATH ${BASIX_PY_DIR}/../fenics_basix.libs)
    endif()

    list(APPEND CMAKE_PREFIX_PATH ${BASIX_PY_DIR})
  else()
    message(STATUS "No Basix hint was found.")
  endif()
endif()

find_package(Basix 0.10 REQUIRED CONFIG)
set_package_properties(
  basix PROPERTIES
  TYPE REQUIRED
  DESCRIPTION "FEniCS tabulation library"
  URL "https://github.com/fenics/basix"
)

# Check for HDF5
set(HDF5_PREFER_PARALLEL TRUE)
set(HDF5_FIND_DEBUG TRUE)
find_package(HDF5 REQUIRED COMPONENTS C)
if(NOT HDF5_IS_PARALLEL)
  message(
    FATAL_ERROR
      "Found serial HDF5, MPI HDF5 build required. Try setting HDF5_DIR or HDF5_ROOT."
  )
endif()

set_package_properties(
  HDF5 PROPERTIES
  TYPE REQUIRED
  DESCRIPTION "Hierarchical Data Format 5 (HDF5)"
  URL "https://www.hdfgroup.org/HDF5"
)

# Check for UFC
# Note: we use the case (ufcx vs UFCx) elsewhere to determine by which
# method UFCx was found.
if(NOT DOLFINX_UFCX_PYTHON)
  # Check in CONFIG mode, i.e. look for installed ufcxConfig.cmake
  find_package(ufcx 0.10 REQUIRED CONFIG)
else()
  # Check in MODULE mode (using FindUFCX.cmake) using Python
  # interpreter
  find_package(Python3 COMPONENTS Interpreter REQUIRED)
  find_package(UFCx 0.10 REQUIRED MODULE)
endif()

set_package_properties(
  UFCx PROPERTIES
  TYPE REQUIRED
  DESCRIPTION "Interface for form-compilers (part of FFCx)"
  URL "https://github.com/fenics/ffcx"
)

# ------------------------------------------------------------------------------
# Find optional packages
if(DOLFINX_ENABLE_ADIOS2 AND _REQUIRE_ADIOS2)
  find_package(ADIOS2 2.8.1 REQUIRED COMPONENTS CXX MPI)
elseif(DOLFINX_ENABLE_ADIOS2)
  find_package(ADIOS2 2.8.1 COMPONENTS CXX MPI)
endif()

if(DOLFINX_ENABLE_PETSC)
  find_package(PkgConfig REQUIRED)
  if (DEFINED ENV{PKG_CONFIG_PATH})
    set(ENV_PKG_CONFIG_PATH $ENV{PKG_CONFIG_PATH})
  else()
    set(ENV_PKG_CONFIG_PATH})
  endif()
  if(DEFINED ENV{PETSC_DIR})
    set(ENV{PKG_CONFIG_PATH} "$ENV{PETSC_DIR}/lib/pkgconfig:ENV_PKG_CONFIG_PATH")
    if(DEFINED ENV{PETSC_ARCH})
      set(ENV{PKG_CONFIG_PATH} "$ENV{PETSC_DIR}/$ENV{PETSC_ARCH}/lib/pkgconfig:$ENV{PKG_CONFIG_PATH}")
    endif()
  endif()

  if(_REQUIRE_PETSC)
    pkg_search_module(PETSC REQUIRED IMPORTED_TARGET PETSc>=3.15 petsc>=3.15)
  else()
    pkg_search_module(PETSC OPTIONAL IMPORTED_TARGET PETSc>=3.15 petsc>=3.15)
  endif()

  # Setting for FeatureSummary
  if(PETSC_FOUND)

=== debian/changelog ===
fenics-dolfinx (1:0.10.0.post5-5) unstable; urgency=medium

  * add powerpc to SKIP_NONLINEAR_PDE_TEST_ARCH_LIST to skip
    test_nonlinear_pde, and also skip
    test_compare_solution_linear_vs_nonlinear_problem
  * fix test skips for bigendian arches (append, don't replace)

 -- Drew Parsons <dparsons@debian.org>  Sun, 01 Feb 2026 13:46:57 +0100

fenics-dolfinx (1:0.10.0.post5-4) unstable; urgency=medium

  * update python-dolfinx Breaks: python3-dolfinx-mpc (<< 0.10~)

 -- Drew Parsons <dparsons@debian.org>  Fri, 02 Jan 2026 12:29:48 +1100

fenics-dolfinx (1:0.10.0.post5-3) unstable; urgency=medium

  * libdolfinx-dev  Breaks: fenicsx-performance-tests-source (<< 0.10~)
    python3-dolfinx Breaks: python3-scifem (<< 0.14~)
  * Standards-Version: 4.7.3

 -- Drew Parsons <dparsons@debian.org>  Mon, 29 Dec 2025 10:23:26 +1100

fenics-dolfinx (1:0.10.0.post5-2) unstable; urgency=medium

  * debian/tests: test-dolfinx-python-demos skip
    demo_scattering_boundary_conditions on i386 with complex numbers
    (vtk 9.5 pushes i386 over its 32-bit memory limit)

 -- Drew Parsons <dparsons@debian.org>  Mon, 22 Dec 2025 23:49:42 +0100

fenics-dolfinx (1:0.10.0.post5-1) unstable; urgency=medium

  * New upstream 0.10 post release
    - applies debian patches fix_partitioner_ghost_PR4003.patch
      fix_scotch_partitioner_PR4001.patch,
      py314_refcount_bunkab84c39.patch
  * update versioned Depends: python3-ffcx (>= 1:0.10.1~),
    python3-ufl (>= 2025.2.0~)

 -- Drew Parsons <dparsons@debian.org>  Sun, 21 Dec 2025 10:36:39 +0100

=== debian/control ===
Source: fenics-dolfinx
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>,
           Francesco Ballarin <francesco.ballarin@unicatt.it>
Section: math
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               gfortran,
               catch2 (>= 3~),
               chrpath,
               libbasix-dev (>= 0.10.0~),
               python3-basix,
               libboost-chrono-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-math-dev,
               libboost-mpi-dev,
               libboost-program-options-dev,
               libboost-serialization-dev,
               libboost-thread-dev,
               libboost-timer-dev,
               libeigen3-dev,
               libhdf5-mpi-dev,
               libadios2-mpi-c++11-dev [amd64 arm64 mips64el ppc64el riscv64 s390x loong64 ppc64 sparc64],
               libpugixml-dev,
               libsuitesparse-dev,
               libptscotch-dev (>= 7.0.10~),
               libxml2-dev,
               mpi-default-dev,
               libpetsc-real-dev,
               libpetsc-complex-dev,
               libslepc-real-dev,
               libslepc-complex-dev,
               python3-setuptools,
               pybuild-plugin-pyproject,
               python3-petsc4py,
               python3-petsc4py-real,
               python3-petsc4py-complex,
               python3-slepc4py,
               python3-slepc4py-real,
               python3-slepc4py-complex,
               pkgconf,
               python3-all-dev,
               python3-cffi,
               python3-ffcx (>= 1:0.10.1~),
               python3-ffcx (<< 1:0.11.0),
               python3-gmsh,
               python3-ufl (>= 2025.2.0~),
               python3-mpi4py,
               python3-nanobind (>= 2.5.0~),
               python3-numpy (>= 1:1.21~),
               python3-numpy-dev,
               python3-pip,
               python3-pytest <!nocheck>,
               python3-pusimp (>= 0.1.1~),
               python3-requests <!nocheck>,
               python3-scikit-build-core,
               python3-scipy <!nocheck>,
               python3-sphinx,
               python3-virtualenv,
               libspdlog-dev
Build-Depends-Indep: doxygen,
                     graphviz,
                     libjs-mathjax,
                     libjs-modernizr,
                     python3-jupytext,
                     python3-matplotlib,
                     python3-myst-parser,
                     python3-sphinx-codeautolink,
                     python3-sphinx-rtd-theme,
                     python-petsc4py-doc,
                     python-numpy-doc,
                     python-mpi4py-doc,
                     basix-doc,
                     python-ffcx-doc,
                     python-ufl-doc
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/science-team/fenics/fenics-dolfinx
Vcs-Git: https://salsa.debian.org/science-team/fenics/fenics-dolfinx.git
Homepage: https://fenicsproject.org
Rules-Requires-Root: no

Package: libdolfinx-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libdolfinx-real-dev (>= ${source:Version}) | libdolfinx-complex-dev (>= ${source:Version}),
         libdolfinx-real-dev (<< ${dolfinx:Next-Upstream-Version}) | libdolfinx-complex-dev (<< ${dolfinx:Next-Upstream-Version}),
         cmake,
         g++ | c++-compiler,
         libboost-chrono-dev,
         libboost-dev,
         libboost-filesystem-dev,
         libboost-iostreams-dev,
         libboost-math-dev,
         libboost-mpi-dev,
         libboost-program-options-dev,
         libboost-serialization-dev,
         libboost-thread-dev,
         libboost-timer-dev,
         libeigen3-dev,
         libhdf5-mpi-dev,
         libadios2-mpi-c++11-dev [amd64 arm64 mips64el ppc64el riscv64 s390x loong64 ppc64 sparc64],
         libpugixml-dev,
         libsuitesparse-dev,
         libptscotch-dev (>= 7.0.10~),
         libspdlog-dev,
         libxml2-dev,
         pkgconf,
         python3-ffcx (>= 1:0.10.1~),
         python3-ffcx (<< 1:0.11.0),
         ${misc:Depends}
Breaks: fenicsx-performance-tests-source (<< 0.10~)
Description: Shared links and header files for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the common development files and depends on
 the real or complex development package.
 .
 This is the next-generation version of libdolfinx-dev (DOLFIN-X).
 The legacy version of DOLFIN is provided by libdolfin-dev.

Package: libdolfinx-real-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libdolfinx-real0.10 (= ${binary:Version}),
         ${petsc:Depends},
         ${misc:Depends}
Recommends: libdolfinx-dev
Description: Shared links and header files for DOLFIN (real numbers)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the development files for the real number build.
 .
 This is the next-generation version of DOLFIN-X.
 The legacy version of DOLFIN is provided by libdolfin-dev.

Package: libdolfinx-complex-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libdolfinx-complex0.10 (= ${binary:Version}),
         ${petsc-complex:Depends},
         ${misc:Depends}
Recommends: libdolfinx-dev
Description: Shared links and header files for DOLFIN (complex numbers)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the development files for the complex number build.
 .
 This is the next-generation version of DOLFIN-).
 The legacy version of DOLFIN is provided by libdolfin-dev.

Package: libdolfinx-real0.10
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: dolfinx-doc,
          python3-dolfinx
Description: Shared libraries for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the shared libraries with real number support.

Package: libdolfinx-complex0.10
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: dolfinx-doc,
          python3-dolfinx
Description: Shared libraries for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the shared libraries with complex number support.

Package: python3-dolfinx
Architecture: any
Multi-Arch: same
Section: python
Depends: python3-dolfinx-real (>= 1:0.10.0~) | python3-dolfinx-complex (>= 1:0.10.0~),
         python3:any,
         ${misc:Depends},
         ${python3:Depends}
Recommends: python3-gmsh
Suggests: dolfinx-doc
Breaks: python3-dolfinx-mpc (<< 0.10~),
 python3-scifem (<< 0.14~)
Description: Python interface for DOLFIN (Python 3)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This is the next-generation version of libdolfinx-dev (DOLFIN-X).
 The legacy version of DOLFIN is provided by python3-dolfin.
 .
 This is a base package depending on the dolfinx packages with
 real or complex number support. By default the version built against
 the preferred version of PETSc in /usr/lib/petsc is selected, but the
 alternative version can be selected by setting the environment
 variable PETSC_DIR.

Package: python3-dolfinx-real
Architecture: any
Section: python
Depends: libdolfinx-dev (= ${binary:Version}),
         libdolfinx-real-dev (= ${binary:Version}),
         python3-ffcx (>= 1:0.10.1~),
         python3-ffcx (<< 1:0.11.0),
         python3-ufl (>= 2025.2.0~),
         python3-cffi,
         python3-mpi4py,
         python3-numpy (>= 1:1.21~),
         python3-pusimp (>= 0.1.1~),
         python3-scipy,
         ${python3-petsc4py-real:Depends},
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: python3-dolfinx
Suggests: dolfinx-doc
Breaks: python3-basix (<< 0.9.0-4~)
Description: Python interface for DOLFIN (Python 3)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the Python interface for DOLFIN (Python 3).
 .
 This is the next-generation version of libdolfinx-dev (DOLFIN-X).
 The legacy version of DOLFIN is provided by python3-dolfin.

Package: python3-dolfinx-complex
Architecture: any
Section: python
Depends: libdolfinx-dev (= ${binary:Version}),
         libdolfinx-complex-dev (= ${binary:Version}),
         python3-ffcx (>= 1:0.10.1~),
         python3-ffcx (<< 1:0.11.0),
         python3-ufl (>= 2025.2.0~),
         python3-cffi,
         python3-mpi4py,
         python3-numpy,
         python3-pusimp (>= 0.1.1~),
         python3-scipy,
         ${python3-petsc4py-complex:Depends},
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: python3-dolfinx
Suggests: dolfinx-doc
Breaks: python3-basix (<< 0.9.0-4~)
Description: Python interface for DOLFIN (Python 3)
 DOLFIN is the Python and C++ interface of the FEniCS project for the

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/architecture.mk

OS_ID := $(shell grep -E "^ID" /etc/os-release | sed "s/^ID=//")

DEB_SOURCE_PACKAGE := $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
DEB_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
DEB_EPOCH := $(shell echo $(DEB_VERSION) | cut -d: -f1)
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -e 's/\+dfsg.*$$//p')

DEBIAN_VERSION_ID := $(OS_ID)_$(DEB_VERSION)

DOLFINX_RELEASE_VERSION=$(DEB_STRIPPED_UPSTREAM_VERSION)
DOLFINX_MAJOR_VERSION=$(shell echo $(DOLFINX_RELEASE_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
DOLFINX_MINOR_VERSION=$(shell echo $(DOLFINX_RELEASE_VERSION) | sed "s/^\([^.]*\)\.\([^.]*\)\..*$$/\2/")
DOLFINX_VERSION=$(DOLFINX_MAJOR_VERSION).$(DOLFINX_MINOR_VERSION)
DOLFINX_NEXT_VERSION=$(DEB_EPOCH):$(DOLFINX_MAJOR_VERSION).$(shell echo $$(( $(DOLFINX_MINOR_VERSION) + 1 )) )

# Allow test programs that use OpenMPI to run
export PRTE_MCA_plm_ssh_agent=/bin/false
export OMPI_MCA_btl_base_warn_component_unused=0
export PRTE_MCA_rmaps_default_mapping_policy=:oversubscribe

DOLFINX_HOME = $(CURDIR)/$(DEB_SRCDIR)
USCAN_DESTDIR := $(CURDIR)
PY3VER_DEFAULT := $(shell py3versions -dv)

BUILDDIR_REAL = $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)-real
BUILDDIR_COMPLEX = $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)-complex

NPROC := $(shell nproc)
PARALLEL = $(subst parallel=,,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
N_CPU    = $(or $(PARALLEL),$(NPROC),1)
# MPI tests are set up to run on 3 processes. Spread them leanly over the available processors (don't have more than 2 tests using one processor).
# e.g. run 1 MPI test at a time over 1-3 processors, or 2 tests at a time over 4-6 processors, or 3 tests over 7-9 processors, etc.
N_MPI := 3
N_MPI_TESTS = $(shell echo $$(( ($(N_CPU)+$(N_MPI)-1)/$(N_MPI) )) )

ifeq (nocheck,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
  RUNTEST=no
endif

# some arches just aren't keeping up at all, and fail non-MPI tests
ARCH_SKIP_ALL_TESTS_LIST = mips64el hurd-i386 m68k sh4

# monitor slow python tests
export PYBUILD_TEST_ARGS = --durations=20

empty :=
space := $(empty)$(empty)

# some tests do not converge on some arches
# test_nonlinear_pde, test_petsc_solver_wrappers.py TestPETScSolverWrappers.test_compare_solvers
# "Newton solver did not converge because maximum number of iterations reached"
SKIP_NONLINEAR_PDE_TEST_ARCH_LIST = mips64el powerpc ppc64
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(SKIP_NONLINEAR_PDE_TEST_ARCH_LIST)$(space)))
    SKIP_TEST_LIST += test_nonlinear_pde test_compare_solvers test_compare_solution_linear_vs_nonlinear_problem
endif

# skip slowest tests on riscv64, which is most of them
ifeq ($(DEB_HOST_ARCH),riscv64)
    SKIP_TEST_LIST += test_symmetry test_curl_curl_eigenvalue test_higher_order_function test_eigen_assembly \
	test_assembler test_fem_pipeline test_dof_permuting test_dofmap test_element_integrals test_xdmf_function \
	test_assemble_submesh test_interpolation test_petsc_discrete_operators test_mesh test_higher_order_mesh
endif

# adios2 is not reliable on bigendian systems (s390x), skip demo_mixed_poisson
ifeq ($(DEB_HOST_ARCH_ENDIAN),big)
  SKIP_TEST_LIST += demo_mixed_poisson_mpi_2 demo_mixed_poisson_mpi_3 demo_mixed_poisson_serial
endif

export PYBUILD_TEST_ARGS += $(shell \
        SKIP_TESTS=""; \
        list_initialised=0; \
        for t in $(SKIP_TEST_LIST); do \
            if [ $${list_initialised} = 0 ]; then \
                SKIP_TESTS=$$t; \
                list_initialised=1; \
            else \
                SKIP_TESTS="$${SKIP_TESTS} or $$t"; \
            fi; \
        done; \
        if [ "x$${SKIP_TESTS}" != "x" ]; then \
            SKIP_TESTS="not ( $${SKIP_TESTS} )"; \
        fi; \
        echo "-k \"$${SKIP_TESTS}\"")

# extract PETSc version from petsc-dev
PETSC_DEB_VERSION=$(shell dpkg -s petsc-dev | awk '/Version:/ {print $2}')
# extract the current PETSc version
PETSC_UPSTREAM_VERSION=$(shell pkg-config --modversion PETSc)
# "Major" version is the first number in the upstream version (major.minor.release)
PETSC_MAJOR_VERSION=$(shell echo $(PETSC_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
# "Minor" version is the second number in the upstream version (major.minor.release)
PETSC_MINOR_VERSION=$(shell echo $(PETSC_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\.\([^.]*\)\..*$$/\2/")
PETSC_VERSION=$(PETSC_MAJOR_VERSION).$(PETSC_MINOR_VERSION)
PETSC_VERSION_NEXT=$(shell echo $(PETSC_MAJOR_VERSION).$$(($(PETSC_MINOR_VERSION)+1)))

SLEPC_UPSTREAM_VERSION=$(shell pkg-config --modversion SLEPc)
# SLEPc version must match PETSc
SLEPC_VERSION=$(PETSC_VERSION)
SLEPC_VERSION_NEXT=$(PETSC_VERSION_NEXT)

PETSC_DIR_BASE=/usr/lib/petscdir/petsc$(PETSC_VERSION)/$(DEB_HOST_MULTIARCH)
SLEPC_DIR_BASE=/usr/lib/slepcdir/slepc$(SLEPC_VERSION)/$(DEB_HOST_MULTIARCH)
export PETSC_DIR_REAL=$(PETSC_DIR_BASE)-real
SLEPC_DIR_REAL=$(SLEPC_DIR_BASE)-real
export PETSC_DIR_COMPLEX=$(PETSC_DIR_BASE)-complex
SLEPC_DIR_COMPLEX=$(SLEPC_DIR_BASE)-complex

DEB_CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS)

ifeq ($(DEB_HOST_ARCH),mips64el)
  DEB_CXXFLAGS += -Wno-error=maybe-uninitialized
endif

CMAKE_OPTS := \
	-D CMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
	-D BUILD_SHARED_LIBS:BOOL=ON \
	-D CMAKE_SKIP_RPATH:BOOL=ON \
	-D CMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=OFF \
	-D DOLFINX_ENABLE_TRILINOS:BOOL=OFF \
	-D DOLFINX_ENABLE_HDF5:BOOL=ON \
	-D HDF5_C_COMPILER_EXECUTABLE:FILEPATH=/usr/bin/h5pcc \
	-D DOLFINX_ENABLE_PARMETIS:BOOL=OFF \
	-D DOLFINX_ENABLE_SCOTCH:BOOL=ON \
	-D DOLFINX_ENABLE_DOCS:BOOL=OFF \
	-D DOLFINX_ENABLE_MPI:BOOL=$(ENABLE_MPI) \
	-D CMAKE_CXX_FLAGS:STRING="-fpermissive" \
	-D DOLFINX_EXTRA_CXX_FLAGS:STRING="$(DEB_CXXFLAGS)" \
	-D DEBIAN_VERSION_ID=$(DEBIAN_VERSION_ID) \
	$(XSIMD_CONFIG)

%:
	dh $@ --buildsystem=cmake --with python3,sphinxdoc

override_dh_compress:
	dh_compress -X.py -X.cpp -X.h -X.pdf -X.ufl

override_dh_auto_clean:
	dh_auto_clean --builddir=$(BUILDDIR_REAL)
	dh_auto_clean --builddir=$(BUILDDIR_COMPLEX)
	rm -rf python/build-real python/build-complex
	rm -rf debian/tmp-real debian/tmp-complex
	rm -rf python/fenics_dolfinx.egg-info
	rm -rf python/doc/build python/doc/source/generated
	rm -rf cpp/doc/latex cpp/doc/html cpp/doc/xml
	rm -rf $(CURDIR)/python/doc/source/demos

override_dh_auto_configure:
	PETSC_DIR=$(PETSC_DIR_REAL) SLEPC_DIR=$(SLEPC_DIR_REAL) dh_auto_configure --builddir=$(BUILDDIR_REAL) -D$(CURDIR)/cpp -- $(CMAKE_OPTS)
	PETSC_DIR=$(PETSC_DIR_COMPLEX) SLEPC_DIR=$(SLEPC_DIR_COMPLEX) dh_auto_configure --builddir=$(BUILDDIR_COMPLEX) -D$(CURDIR)/cpp -- $(CMAKE_OPTS)

override_dh_auto_build:
	PETSC_DIR=$(PETSC_DIR_REAL) SLEPC_DIR=$(SLEPC_DIR_REAL) dh_auto_build --builddir=$(BUILDDIR_REAL)
	PETSC_DIR=$(PETSC_DIR_COMPLEX) SLEPC_DIR=$(SLEPC_DIR_COMPLEX) dh_auto_build --builddir=$(BUILDDIR_COMPLEX)

override_dh_auto_test-arch:
	echo "Tests must be run after installation"

override_dh_auto_test-indep:

debian/tmp-real:
	dh_auto_install --builddir=$(BUILDDIR_REAL) --destdir=debian/tmp-real
	cp COPYING.LESSER python
	for build in real; do \
		PATH=$(CURDIR)/debian/tmp-$${build}/usr/bin:$$PATH \
		PETSC_DIR=$(PETSC_DIR_BASE)-$${build} SLEPC_DIR=$(SLEPC_DIR_BASE)-$${build} \
		CXXFLAGS="$(DEB_CXXFLAGS) -isystem $(CURDIR)/debian/tmp-$${build}/usr/include" \
		VERBOSE=1 \
		ADIOS2_ALWAYS_USE_MPI=1 \
		PUSIMP_EXPECT_DOLFINX_IN_CWD=1 \
		pybuild --dir=$(CURDIR)/python --dest-dir=$(CURDIR)/debian/tmp-$${build} --system=pyproject --name=dolfinx-$${build} --test-pytest; \
	done

override_dh_auto_install-indep: debian/tmp-real
	dh_auto_install -i --builddir=$(BUILDDIR_COMPLEX) --destdir=debian/tmp-complex
	(cd cpp/doc; doxygen)
	(cd python/doc; \
	  mkdir -p build/pkgconfig; \
